/*
 * @Author: your name
 * @Date: 2022-03-09 17:59:19
 * @LastEditTime: 2022-03-09 18:25:11
 * @LastEditors: Please set LastEditors
 * @Description: 打开koroFileHeader查看配置 进行设置:
 * https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 * @FilePath: /dev_roadmodel_ros2/src/mpc_drv_ctAp_rm/src/update_local_view.h
 */
#pragma once

#include <chrono>
#include <iostream>
#include <mutex>
#include <thread>

// #include "mpc_drv_msgs/msg/vehicle_state_output.hpp"
// #include "mpc_drv_msgs/msg/control_waypoints.hpp"
// #include "mpc_drv_msgs/msg/msg_sm2_ba.hpp"
// #include "mpc_drv_msgs/msg/road_info.hpp"

#include "local_view.h"
#include "ros_recv.h"
// #include "interface/ved_dpc_interface.h"
// #include "interface/slam_decision.h"

using namespace BA;
// 20240330: uncomment this part and do certain changes
#if 1
void UpdateLocalView(
    LocalView &local_view,
    dpc::RoadInfo &road_model,
    dpc::VED4DPC &vehicle_state,
    dpc::SM4Decision &system_management,
    dpc::ControlWaypoints &control_waypoints)
{
  {
    local_view.road_model = std::make_shared<dpc::RoadInfo>(road_model);
    cout << "ego lane id from rm: " << int(local_view.road_model->car_position.ego_lane_id) << std::endl;
  }
  {
    local_view.vehicle_state = std::make_shared<dpc::VED4DPC>(vehicle_state);
  }
  {
    local_view.system_management = std::make_shared<dpc::SM4Decision>(system_management);
    local_view.system_management->sm_lfcmfrtavlbhvr = 3;
    local_view.system_management->sm_drvrsetspd = 10;
    cout << "lfcmft status: " << int(local_view.system_management->sm_lfcmfrtavlbhvr) << std::endl;
    cout << "set speed: " << local_view.system_management->sm_drvrsetspd << std::endl;
  }
  {
    local_view.control_waypoints = std::make_shared<dpc::ControlWaypoints>(control_waypoints);
  }
}
#endif
